Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs	(revision 13411)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs	(revision 13412)
@@ -1,28 +1,40 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Optimization;
-using HeuristicLab.PluginInfrastructure;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Problems.Instances;
-using HeuristicLab.Encodings.PermutationEncoding;
-using HeuristicLab.Common;
-using HeuristicLab.Parameters;
-using HeuristicLab.Data;
 
 namespace HeuristicLab.Problems.PTSP {
-  [Item("Analytical Probabilistic Traveling Salesman Problem", "Represents an analytical Probabilistic Traveling Salesman Problem.")]
-  [Creatable("Problems")]
+  [Item("Analytical Probabilistic Traveling Salesman Problem (PTSP)", "Represents a probabilistic traveling salesman problem where the expected tour length is calculated exactly.")]
+  [Creatable(CreatableAttribute.Categories.CombinatorialProblems)]
   [StorableClass]
-  public sealed class AnalyticalProbabilisticTravelingSalesmanProblem : ProbabilisticTravelingSalesmanProblem, IStorableContent,
-  IProblemInstanceConsumer<PTSPData> {
+  public sealed class AnalyticalProbabilisticTravelingSalesmanProblem : ProbabilisticTravelingSalesmanProblem {
 
     [StorableConstructor]
     private AnalyticalProbabilisticTravelingSalesmanProblem(bool deserializing) : base(deserializing) { }
-    private AnalyticalProbabilisticTravelingSalesmanProblem(AnalyticalProbabilisticTravelingSalesmanProblem original, Cloner cloner)
-      : base(original, cloner) {
+    private AnalyticalProbabilisticTravelingSalesmanProblem(AnalyticalProbabilisticTravelingSalesmanProblem original, Cloner cloner) : base(original, cloner) { }
+    public AnalyticalProbabilisticTravelingSalesmanProblem() {
+      Operators.Add(new BestPTSPSolutionAnalyzer());
     }
 
@@ -31,117 +43,59 @@
     }
 
-    public override double Evaluate(Individual individual, IRandom random) {
-      Permutation p = individual.Permutation();
-      // Compute A and B matrices
-      DoubleMatrix A = new DoubleMatrix(p.Length, p.Length - 1);
-      DoubleMatrix B = new DoubleMatrix(p.Length, p.Length - 1);
-      //for (int i = 0; i < p.Length; i++) {
-      //  for (int k = 0; k < p.Length - 1; k++) {
-      //    double firstPartial = 0;
-      //    for (int r = k; k < p.Length - 1; r++) {
-      //       double sum0 = DistanceMatrix[p[i],p[i+r]]* ProbabilityMatrix[0, p[i]] * ProbabilityMatrix[0, p[i+r]];
-      //       for(int s = i+1; s < i+r; s++) {
-      //         sum0 = sum0 * (1 - ProbabilityMatrix[0, p[s]]);
-      //       }
-      //       firstPartial+=sum0;
-      //    }
-      //    double secondPartial = 0;
-      //    for (int r = k; k < p.Length - 1; r++) {
-      //       double sum1 = DistanceMatrix[p[i-r],p[i]]* ProbabilityMatrix[0, p[i-r]] * ProbabilityMatrix[0, p[i]];
-      //       for (int s = i + 1; s < p.Length-1; s++) {
-      //         sum1 = sum1 * (1 - ProbabilityMatrix[0, p[s]]);
-      //       }
-      //       for (int t = 1; t < i-1; t++) {
-      //         sum1 = sum1 * (1 - ProbabilityMatrix[0, p[t]]);
-      //       }
-      //       secondPartial+=sum1;
-      //    }
-      //    A[i, k] = firstPartial;
-      //    B[i, k] = secondPartial;
-      //  }
-      //}
-      
+    public override double Evaluate(Permutation tour, IRandom random) {
       // Analytical evaluation
       double firstSum = 0;
-      for (int i = 0; i < p.Length - 1; i++) {
-        for (int j = i + 1; j < p.Length - 1; j++) {
-          double sum1 = DistanceMatrix[p[i], p[j]] * ProbabilityMatrix[p[i]] * ProbabilityMatrix[p[j]];
+      for (int i = 0; i < tour.Length - 1; i++) {
+        for (int j = i + 1; j < tour.Length - 1; j++) {
+          double sum1 = DistanceMatrix[tour[i], tour[j]] * Probabilities[tour[i]] * Probabilities[tour[j]];
           for (int k = i + 1; k < j; k++) {
-            sum1 = sum1 * (1 - ProbabilityMatrix[p[k]]);
+            sum1 = sum1 * (1 - Probabilities[tour[k]]);
           }
-          A[i, j - 1] = sum1;
           firstSum += sum1;
         }
       }
       double secondSum = 0;
-      for (int j = 0; j < p.Length - 1; j++) {
+      for (int j = 0; j < tour.Length - 1; j++) {
         for (int i = 0; i < j; i++) {
-          double sum2 = DistanceMatrix[p[j], p[i]] * ProbabilityMatrix[p[i]] * ProbabilityMatrix[p[j]];
-          for (int k = j + 1; k < p.Length - 1; k++) {
-            sum2 = sum2 * (1 - ProbabilityMatrix[p[k]]);
+          double sum2 = DistanceMatrix[tour[j], tour[i]] * Probabilities[tour[i]] * Probabilities[tour[j]];
+          for (int k = j + 1; k < tour.Length - 1; k++) {
+            sum2 = sum2 * (1 - Probabilities[tour[k]]);
           }
           for (int k = 1; k < i; k++) {
-            sum2 = sum2 * (1 - ProbabilityMatrix[p[k]]);
+            sum2 = sum2 * (1 - Probabilities[tour[k]]);
           }
-          B[i, j] = sum2;
           secondSum += sum2;
         }
-      }
-      foreach (var op in Operators.OfType<PTSPAnalyticalInversionMovePathEvaluator>()) {
-        op.AParameter.Value = A;
-        op.BParameter.Value = B;
       }
       return firstSum + secondSum;
     }
 
-    public double EvaluateWithParams(DistanceMatrix distances, DoubleArray probabilities, Permutation individual) {
-      Permutation p = individual;
-      // Compute A and B matrices
-      DoubleMatrix A = new DoubleMatrix(p.Length, p.Length - 1);
-      DoubleMatrix B = new DoubleMatrix(p.Length, p.Length - 1);
+    public static double Evaluate(Permutation tour, DistanceMatrix distanceMatrix, DoubleArray probabilities) {
       // Analytical evaluation
-      double firstSum = 0;
-      for (int i = 0; i < p.Length; i++) {
-        for (int j = i + 1; j < p.Length; j++) {
-          double sum1 = distances[p[i], p[j]] * probabilities[p[i]] * probabilities[p[j]];
-          for (int k = i + 1; k < j; k++) {
-            sum1 = sum1 * (1 - probabilities[p[k]]);
+      var firstSum = 0.0;
+      for (var i = 0; i < tour.Length; i++) {
+        for (var j = i + 1; j < tour.Length; j++) {
+          var sum1 = distanceMatrix[tour[i], tour[j]] * probabilities[tour[i]] * probabilities[tour[j]];
+          for (var k = i + 1; k < j; k++) {
+            sum1 = sum1 * (1 - probabilities[tour[k]]);
           }
-          A[i, j - 1] = sum1;
           firstSum += sum1;
         }
       }
-      double secondSum = 0;
-      for (int j = 0; j < p.Length; j++) {
-        for (int i = 0; i < j; i++) {
-          double sum2 = distances[p[j], p[i]] * probabilities[p[i]] * probabilities[p[j]];
-          for (int k = j + 1; k < p.Length; k++) {
-            sum2 = sum2 * (1 - probabilities[p[k]]);
+      var secondSum = 0.0;
+      for (var j = 0; j < tour.Length; j++) {
+        for (var i = 0; i < j; i++) {
+          var sum2 = distanceMatrix[tour[j], tour[i]] * probabilities[tour[i]] * probabilities[tour[j]];
+          for (var k = j + 1; k < tour.Length; k++) {
+            sum2 = sum2 * (1 - probabilities[tour[k]]);
           }
-          for (int k = 0; k < i; k++) {
-            sum2 = sum2 * (1 - probabilities[p[k]]);
+          for (var k = 0; k < i; k++) {
+            sum2 = sum2 * (1 - probabilities[tour[k]]);
           }
-          B[j,i] = sum2;
           secondSum += sum2;
         }
       }
-      foreach (var op in Operators.OfType<PTSPAnalyticalInversionMovePathEvaluator>()) {
-        op.AParameter.Value = A;
-        op.BParameter.Value = B;
-      }
       return firstSum + secondSum;
     }
-
-    public AnalyticalProbabilisticTravelingSalesmanProblem() {
-      Operators.Add(new PTSPAnalyticalInversionMovePathEvaluator());
-    }
-
-    public override void Load(PTSPData data) {
-      base.Load(data);
-      foreach (var op in Operators.OfType<PTSPAnalyticalInversionMovePathEvaluator>()) {
-        op.ProbabilitiesParameter.Value = ProbabilityMatrix;
-      }
-    }
-
   }
 }
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/Analyzers/BestPTSPSolutionAnalyzer.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/Analyzers/BestPTSPSolutionAnalyzer.cs	(revision 13411)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/Analyzers/BestPTSPSolutionAnalyzer.cs	(revision 13412)
@@ -32,5 +32,5 @@
 namespace HeuristicLab.Problems.PTSP {
   /// <summary>
-  /// An operator for analyzing the best solution of Traveling Salesman Problems given in path representation using city coordinates.
+  /// An operator for analyzing the best solution of probabilistic traveling salesman problems given in path representation.
   /// </summary>
   [Item("BestPTSPSolutionAnalyzer", "An operator for analyzing the best solution of Probabilistic Traveling Salesman Problems given in path representation using city coordinates.")]
@@ -41,30 +41,30 @@
     }
 
-    public LookupParameter<BoolValue> MaximizationParameter {
-      get { return (LookupParameter<BoolValue>)Parameters["Maximization"]; }
+    public ILookupParameter<BoolValue> MaximizationParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters["Maximization"]; }
     }
-    public LookupParameter<DoubleMatrix> CoordinatesParameter {
-      get { return (LookupParameter<DoubleMatrix>)Parameters["Coordinates"]; }
+    public ILookupParameter<DoubleMatrix> CoordinatesParameter {
+      get { return (ILookupParameter<DoubleMatrix>)Parameters["Coordinates"]; }
     }
-    public ScopeTreeLookupParameter<Permutation> PermutationParameter {
-      get { return (ScopeTreeLookupParameter<Permutation>)Parameters["Permutation"]; }
+    public IScopeTreeLookupParameter<Permutation> PermutationParameter {
+      get { return (IScopeTreeLookupParameter<Permutation>)Parameters["Permutation"]; }
     }
-    public ScopeTreeLookupParameter<DoubleValue> QualityParameter {
-      get { return (ScopeTreeLookupParameter<DoubleValue>)Parameters["Quality"]; }
+    public IScopeTreeLookupParameter<DoubleValue> QualityParameter {
+      get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-    public LookupParameter<DoubleArray> ProbabilityMatrixParameter {
-      get { return (LookupParameter<DoubleArray>)Parameters["ProbabilityMatrix"]; }
+    public ILookupParameter<DoubleArray> ProbabilitiesParameter {
+      get { return (ILookupParameter<DoubleArray>)Parameters["Probabilities"]; }
     }
-    public LookupParameter<PathPTSPTour> BestSolutionParameter {
-      get { return (LookupParameter<PathPTSPTour>)Parameters["BestSolution"]; }
+    public ILookupParameter<PathPTSPTour> BestSolutionParameter {
+      get { return (ILookupParameter<PathPTSPTour>)Parameters["BestSolution"]; }
     }
-    public ValueLookupParameter<ResultCollection> ResultsParameter {
-      get { return (ValueLookupParameter<ResultCollection>)Parameters["Results"]; }
+    public IValueLookupParameter<ResultCollection> ResultsParameter {
+      get { return (IValueLookupParameter<ResultCollection>)Parameters["Results"]; }
     }
-    public LookupParameter<DoubleValue> BestKnownQualityParameter {
-      get { return (LookupParameter<DoubleValue>)Parameters["BestKnownQuality"]; }
+    public ILookupParameter<DoubleValue> BestKnownQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["BestKnownQuality"]; }
     }
-    public LookupParameter<Permutation> BestKnownSolutionParameter {
-      get { return (LookupParameter<Permutation>)Parameters["BestKnownSolution"]; }
+    public ILookupParameter<Permutation> BestKnownSolutionParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["BestKnownSolution"]; }
     }
 
@@ -81,34 +81,22 @@
       Parameters.Add(new ScopeTreeLookupParameter<Permutation>("Permutation", "The PTSP solutions given in path representation from which the best solution should be analyzed."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the PTSP solutions which should be analyzed."));
-      Parameters.Add(new LookupParameter<DoubleArray>("ProbabilityMatrix", "The matrix which contains the probabilities of each of the cities."));
+      Parameters.Add(new LookupParameter<DoubleArray>("Probabilities", "This list describes for each city the probability of appearing in a realized instance."));
       Parameters.Add(new LookupParameter<PathPTSPTour>("BestSolution", "The best PTSP solution."));
       Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The result collection where the best PTSP solution should be stored."));
       Parameters.Add(new LookupParameter<DoubleValue>("BestKnownQuality", "The quality of the best known solution of this PTSP instance."));
       Parameters.Add(new LookupParameter<Permutation>("BestKnownSolution", "The best known solution of this PTSP instance."));
-
-      MaximizationParameter.Hidden = true;
-      CoordinatesParameter.Hidden = true;
-      PermutationParameter.Hidden = true;
-      QualityParameter.Hidden = true;
-      ProbabilityMatrixParameter.Hidden = true;
-      BestSolutionParameter.Hidden = true;
-      ResultsParameter.Hidden = true;
-      BestKnownQualityParameter.Hidden = true;
-      BestKnownSolutionParameter.Hidden = true;
     }
 
     public override IOperation Apply() {
-      DoubleMatrix coordinates = CoordinatesParameter.ActualValue;
-      ItemArray<Permutation> permutations = PermutationParameter.ActualValue;
-      ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
-      DoubleArray probabilities = ProbabilityMatrixParameter.ActualValue;
-      ResultCollection results = ResultsParameter.ActualValue;
-      bool max = MaximizationParameter.ActualValue.Value;
-      DoubleValue bestKnownQuality = BestKnownQualityParameter.ActualValue;
+      var coordinates = CoordinatesParameter.ActualValue;
+      var permutations = PermutationParameter.ActualValue;
+      var qualities = QualityParameter.ActualValue;
+      var probabilities = ProbabilitiesParameter.ActualValue;
+      var results = ResultsParameter.ActualValue;
+      var max = MaximizationParameter.ActualValue.Value;
+      var bestKnownQuality = BestKnownQualityParameter.ActualValue;
 
-      int i = -1;
-      if (!max)
-        i = qualities.Select((x, index) => new { index, x.Value }).OrderBy(x => x.Value).First().index;
-      else i = qualities.Select((x, index) => new { index, x.Value }).OrderByDescending(x => x.Value).First().index;
+      var i = !max ? qualities.Select((x, index) => new { index, x.Value }).OrderBy(x => x.Value).First().index
+                   : qualities.Select((x, index) => new { index, x.Value }).OrderByDescending(x => x.Value).First().index;
 
       if (bestKnownQuality == null ||
@@ -119,7 +107,7 @@
       }
 
-      PathPTSPTour tour = BestSolutionParameter.ActualValue;
+      var tour = BestSolutionParameter.ActualValue;
       if (tour == null) {
-        tour = new PathPTSPTour(coordinates,probabilities, (Permutation)permutations[i].Clone(), new DoubleValue(qualities[i].Value));
+        tour = new PathPTSPTour(coordinates, probabilities, (Permutation)permutations[i].Clone(), new DoubleValue(qualities[i].Value));
         BestSolutionParameter.ActualValue = tour;
         results.Add(new Result("Best PTSP Solution", tour));
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/AttDistance.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/AttDistance.cs	(revision 13412)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/AttDistance.cs	(revision 13412)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.PTSP {
+  [Item("Att Distance", "Calculates the att distance.")]
+  [StorableClass]
+  public sealed class AttDistance : DistanceCalculator {
+
+    [StorableConstructor]
+    private AttDistance(bool deserializing) : base(deserializing) { }
+    private AttDistance(AttDistance original, Cloner cloner) : base(original, cloner) { }
+    public AttDistance() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AttDistance(this, cloner);
+    }
+
+    public override double Calculate(int from, int to, DoubleMatrix coordinates) {
+      return DistanceHelper.GetDistance(DistanceMeasure.Att, coordinates[from, 0], coordinates[from, 1], coordinates[to, 0], coordinates[to, 1]);
+    }
+  }
+}
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/DistanceCalculator.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/DistanceCalculator.cs	(revision 13412)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/DistanceCalculator.cs	(revision 13412)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.PTSP {
+  [Item("Distance calculator", "Calculates the distance between two cities given as index of a coordinates matrix.")]
+  [StorableClass]
+  public abstract class DistanceCalculator : Item {
+    [StorableConstructor]
+    protected DistanceCalculator(bool deserializing) : base(deserializing) { }
+    protected DistanceCalculator(DistanceCalculator original, Cloner cloner) : base(original, cloner) { }
+    protected DistanceCalculator() { }
+
+    public abstract double Calculate(int from, int to, DoubleMatrix coordinates);
+  }
+}
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/EuclideanDistance.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/EuclideanDistance.cs	(revision 13412)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/EuclideanDistance.cs	(revision 13412)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.PTSP {
+  [Item("Euclidean Distance", "Calculates the euclidean distance.")]
+  [StorableClass]
+  public sealed class EuclideanDistance : DistanceCalculator {
+
+    [StorableConstructor]
+    private EuclideanDistance(bool deserializing) : base(deserializing) { }
+    private EuclideanDistance(EuclideanDistance original, Cloner cloner) : base(original, cloner) { }
+    public EuclideanDistance() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EuclideanDistance(this, cloner);
+    }
+
+    public override double Calculate(int from, int to, DoubleMatrix coordinates) {
+      return DistanceHelper.GetDistance(DistanceMeasure.Euclidean, coordinates[from, 0], coordinates[from, 1], coordinates[to, 0], coordinates[to, 1]);
+    }
+  }
+}
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/GeoDistance.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/GeoDistance.cs	(revision 13412)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/GeoDistance.cs	(revision 13412)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.PTSP {
+  [Item("Geo Distance", "Calculates the geo distance.")]
+  [StorableClass]
+  public sealed class GeoDistance : DistanceCalculator {
+
+    [StorableConstructor]
+    private GeoDistance(bool deserializing) : base(deserializing) { }
+    private GeoDistance(GeoDistance original, Cloner cloner) : base(original, cloner) { }
+    public GeoDistance() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GeoDistance(this, cloner);
+    }
+
+    public override double Calculate(int from, int to, DoubleMatrix coordinates) {
+      return DistanceHelper.GetDistance(DistanceMeasure.Geo, coordinates[from, 0], coordinates[from, 1], coordinates[to, 0], coordinates[to, 1]);
+    }
+  }
+}
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/ManhattanDistance.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/ManhattanDistance.cs	(revision 13412)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/ManhattanDistance.cs	(revision 13412)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.PTSP {
+  [Item("Manhattan Distance", "Calculates the Manhattan distance.")]
+  [StorableClass]
+  public sealed class ManhattanDistance : DistanceCalculator {
+
+    [StorableConstructor]
+    private ManhattanDistance(bool deserializing) : base(deserializing) { }
+    private ManhattanDistance(ManhattanDistance original, Cloner cloner) : base(original, cloner) { }
+    public ManhattanDistance() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ManhattanDistance(this, cloner);
+    }
+
+    public override double Calculate(int from, int to, DoubleMatrix coordinates) {
+      return DistanceHelper.GetDistance(DistanceMeasure.Manhattan, coordinates[from, 0], coordinates[from, 1], coordinates[to, 0], coordinates[to, 1]);
+    }
+  }
+}
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/MaximumDistance.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/MaximumDistance.cs	(revision 13412)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/DistanceCalculators/MaximumDistance.cs	(revision 13412)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.PTSP {
+  [Item("Maximum Distance", "Calculates the maximum distance.")]
+  [StorableClass]
+  public sealed class MaximumDistance : DistanceCalculator {
+
+    [StorableConstructor]
+    private MaximumDistance(bool deserializing) : base(deserializing) { }
+    private MaximumDistance(MaximumDistance original, Cloner cloner) : base(original, cloner) { }
+    public MaximumDistance() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MaximumDistance(this, cloner);
+    }
+
+    public override double Calculate(int from, int to, DoubleMatrix coordinates) {
+      return DistanceHelper.GetDistance(DistanceMeasure.Maximum, coordinates[from, 0], coordinates[from, 1], coordinates[to, 0], coordinates[to, 1]);
+    }
+  }
+}
